 
function PageQuery(url) {
  var start = url.indexOf('?'); if(start>=0) url=url.slice(start+1);
  var items = url.split('&')
  var rec = {};
  for(var i=0; i < items.length; i++)  {
    kv = items[i].split('=',2)
    if( kv.length > 1 ) rec[ unescape(kv[0]) ] = unescape(kv[1]);
  }
  return rec;
}

// -------------------------  Cookies  -------------------------

function getCookie(cname) {
  var name = cname + "=";
  var ca = decodeURIComponent(document.cookie).split(';');
  for(var i in ca) {
    var c = ca[i], j=0;
    while ( j < c.length && c.charAt(j)==' ' ) j++
    if ( name == c.substr(j,name.length) ) {
      return c.substring(j+name.length, c.length);
    }
  }
  return "";
}

function setCookie(cname, cvalue, exdays) {
  var d = new Date();
  d.setTime(d.getTime() + (exdays*24*60*60*1000));
  var expires = "expires="+ d.toUTCString();
  document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
}

// -------------------------  HTTP & DOM  -------------------------

var verbose = false;
var oRequest, error = 0;

function HttpGET(sURL,ContentType) {
  var oRequest; error = 0
  try {
    if(window.ActiveXObject) try { oRequest = new ActiveXObject('Msxml2.XMLHTTP'); } catch(e) { oRequest = new ActiveXObject('Microsoft.XMLHTTP'); } 
    oRequest = new XMLHttpRequest();
    oRequest.open("GET",sURL,false);
    //oRequest.setRequestHeader("User-Agent",navigator.userAgent);
    if(ContentType) oRequest.setRequestHeader("Content-Type",ContentType);
    oRequest.send(null);
    if (oRequest.status!=200) { error=status||2; if(verbose) alert(oRequest.status); }
  } catch(e) { error=1; if(verbose) alert(e); }
  return oRequest
}

function HttpGETxml(sURL) {
  var o = HttpGET(sURL,"text/xml");
  var dom = o.responseXML;  
  if (!dom) dom = (new DOMParser()).parseFromString(o.responseText, "text/xml");
  return dom.documentElement
}

function htmlencode(raw) {
  var i,cooked=""; if(!raw) return raw;
  for(i=0;i<raw.length;i++) { 
    asc=raw.charCodeAt(i)
    //cooked=cooked+"<"+asc+">";
    // ae as returned for März in datetime.toLocaleString() for Konqueror 4 & Konqueror 3
    if (asc==65475 && i+1<raw.length && raw.charCodeAt(i+1)==65444) { cooked=cooked+'&auml;'; i++; } else
    if (asc==195 && i+1<raw.length && raw.charCodeAt(i+1)==164) { cooked=cooked+'&auml;'; i++; } else
    if (asc<32||asc>122) cooked=cooked+"&#"+asc+";";
    else cooked=cooked+raw[i];
  }
  return cooked;
}

function getText(xmlnode) { var n
  for(n=xmlnode.firstChild; n; n=n.nextSibling)
   if(n.nodeType==3) return n.nodeValue;
}

function TextOf(domobj) {
  var txt = domobj.innerText || domobj.textContent || domobj.innerHTML;
  return lstrip(txt);
}

function getStyle(el,styleProp,pseudoSel) {  // pseudoSel: null, "", ::after  ~ getStyle(myElementId,"padding-right",null)
  var st;
  if(document.defaultView && document.defaultView.getComputedStyle) {
    st = document.defaultView.getComputedStyle(el,pseudoSel).getPropertyValue(styleProp);
  } else if(window.getComputedStyle) {
    st = window.getComputedStyle(el,pseudoSel).getPropertyValue(styleProp);
  } else if(el.currentStyle) {
    styleProp = styleProp.replace(/\-(\w)/g, function (strMatch, p1){ return p1.toUpperCase(); });   // "padding-right" -> "paddingRight"
    st = el.currentStyle[styleProp];
  }
  return st;
}

function Minus(prop) {
  if(typeof(prop)=='number') var res = prop>0 ? -prop : prop;
  else if(typeof(prop)=='string') var res = prop.length>0 && prop[0]!='-' ? '-'+prop : prop; 
  else var res = prop;
  return res;
}

function makeRecord(xmlnode) {
  var n, rec = {}
  for(n=xmlnode.firstChild; n; n=n.nextSibling)
    rec[n.nodeName] = getText(n)
  return rec
}

function IncludeDoc(frameid,sURL,defaultHeight,descr) {
  var oRequest = HttpGET(sURL,"text/html")
  if (error==0) document.write(oRequest.responseText)
  else { 
    document.write('<iframe src="'+ sURL +'" frameborder=0 width=100% height='+defaultHeight+' id='+frameid+' onLoad=adjustframe(this,true) >')
    document.write('<h3><a href='+ sURL +'>'+ descr +'</a></h3>');
    document.write('</iframe>')
  }
}

function adjustframe(iframe,mkSmaller) { mkSmaller = 2; // mkSmaller ~ true
  var doc = null, docHeight = 0, iframeHeight = null;

  if( iframe.contentWindow.documentElement ) doc = iframe.contentWindow.documentElement; // fires with Firefox
  else if ( iframe.contentWindow.contentDocument ) doc = iframe.contentWindow.contentDocument; 
  else if ( iframe.contentWindow.document ) doc = iframe.contentWindow.document;

  if( mkSmaller==2 ) iframe.style.height=null;
  if(doc) docHeight = doc.scrollHeight || doc.offsetHeight || doc.clientHeight || ( doc.body && (doc.body.scrollHeight || doc.body.offsetHeight || doc.body.clientHeight ) ) || ( doc.documentElement && (doc.documentElement.scrollHeight || doc.documentElement.offsetHeight || doc.documentElement.clientHeight ) ) || (doc.activeElement.scrollHeight || doc.activeElement.offsetHeight || doc.activeElement.clientHeight ); 
  else docHeight = iframe.contentWindow.innerHeight;

  iframeHeight = iframe.offsetHeight || iframe.clientHeight;
  docWidth = document.offsetWidth || document.clientWidth || document.firstChild.offsetWidth || document.firstChild.clientWidth;

  /*
  if(!iframe.oldHeights) iframe.oldHeights = {};

  if( mkSmaller === true ) {  /// i.e. !== 2
    var rememberedWidth = null, rememberedHeight = null;
    for( curHeight in iframe.oldHeights ) 
      if( iframe.oldHeights[curHeight] <= docWidth && ( rememberedHeight === null || rememberedHeight > curHeight ) ) {
	rememberedWidth = iframe.oldHeights[curHeight];
        rememberedHeight = curHeight;	
      }

    if ( rememberedWidth !== null ) { 
      iframe.style.height = rememberedHeight + 'px';
      return;
    }
  }   */

  // alert(iframeHeight+'/'+docHeight+':'+mkSmaller);  // Konqueror: mkSmaller does not work: 
  if ( docHeight && !iframeHeight || docHeight + 15 > iframeHeight || mkSmaller === 2 && ( docHeight < iframeHeight ) ) {
    iframe.style.height = ( docHeight + 15 ) +  'px';
  }
  iframe.style.overflow = 'auto';   // hidden
  iframe.scrolling = 'auto';
  if( mkSmaller !== 2 )
    if( !( docHeight in iframe.oldHeights ) || ( iframe.oldHeights[docHeight] > docWidth ) )  {
      iframe.oldHeights[docHeight] = docWidth; }
}

// ----------------------  plain Javascript -----------------------

  function lstrip(str) {
    //for(i=0; i<str.length; i++) if str.charAt(i)!=" " break;
    var i=0; while( i<str.length && (str.charAt(i)==" "||str.charAt(i)=="\n") ) i++;
    return str.slice(i);  // everything from 'i' on
  }
  
  function oo(obj) {  // obj-out
    var txt = "" , val="";
    var fngetter = new RegExp("[ \t\n]*function[ \t\nA-Za-z0-9]*([^)]+[)])","i")
    for (key in obj) {
      if(txt) txt += ", "
      //var val = new String()
      var fn = fngetter.exec(obj[key]);
      //if(lstrip(val.substr(0,9))=="function") txt +=  val.substr(0,val.indexOf(')')+1)
      if(fn) txt += key + fn[1];
      else txt += key + "=" + obj[key] ;
    }
    return txt
  }
  
  function aryconc(ary1,ary2) { var i;
    for(i=0;i<ary2.length;i++) ary1.push(ary2[i]);
    return ary1;
  }

  function join(ary,sep) { var i,txt; sep=sep||", ";
    if(ary.length>0) txt = ary[0]; else txt="";
    for(i=1; i<ary.length; i++) txt += sep + ary[i];
    return txt;
  }
  
  function map(fn,ary) { var i;
    for(i=0; i<ary.length; i++) try { ary[i] = fn(ary[i]); } catch(e) { ary[i]=null; }
    return ary
  }

  function inbox(px,py, rx,ry,rw,rh) {
    //alert(join([px,rx,rx+rw, py,ry,ry+rh],", "))
    return rx<=px && px<=rx+rw && ry<=py && py<=ry+rh;
  }
  
  function getindex(string,elm) {
    var idx = string.indexOf(elm);
    return (idx<0) ? string.length : idx ;
  }

  function getLastIndex(string,elm) {
    var idx = string.lastIndexOf(elm);
    return (idx<0) ? string.length : idx ;
  }

// ------------------ misc ------------------

function getLang() {

    if (navigator.language)
      language = navigator.language
    else if (navigator.userLanguage)
       anguage = navigator.userLanguage
    else if (navigator.browserLanguage)
       anguage = navigator.browserLanguage
    else
      anguage = navigator.language;

  if (getindex(language,"de") < getindex(language,"en")) return "de"; else return "en";
}


// ------------------ Link Hiding ------------------

var execchecked = 0;
function checkexec() {
  if(execchecked==0) {
    if( (clientRect(document.body.firstChild)).y <= (clientRect(document.body.lastChild)).y ) execchecked=1; else execchecked=2;}
  return execchecked==1;
}

function adjustLinks() {
  var ell, newtg, instg, tg, ref, p, linktag='bdo'
  if(!checkexec()) return;
  ell = document.getElementsByTagName(linktag);
  if(ell.length<=0) ell = document.getElementsByName(linktag);
  
  for(i=0; i<ell.length; i++) {
    //alert(ell[i].innerHTML);
    newtg = document.createElement("a");
    newtg.innerHTML = ell[i].innerHTML;
    instg = ell[i];
    tg = ell[i].getAttribute('target')
    ref = ell[i].getAttribute('href')
    p=ell[i].parentNode
    if(!ref) {
      if(p.nodeName=="A") { ref = p.getAttribute('href'); p.setAttribute('href',''); 
     			    instg = p; p = p.parentNode; }
      if(!ref) continue;
      if(!tg) tg="_window"; //tg=ref=ell[i].parentNode.getAttribute('target')
      // einziger Grund um a & bdo zu verschachteln: target=_window
    }
    if(tg!='_window') {
      newtg.setAttribute('href',ref);
      newtg.setAttribute('target',tg);
    } else {
      //newtg.setAttribute('href','#');
      newtg.setAttribute('onclick','window.open("'+ref+'","'+(ell[i].getAttribute('opt')||'')+'")')
    }
    p.insertBefore(newtg,instg)
 // p.removeChild(ell[i])
//     document.replaceChild(ell[i],newtg);
  }
  while(ell.length>0) {
    for(i=0; i<ell.length; i++) {
      p=ell[i].parentNode
      p.removeChild(ell[i])
    }
    ell = document.getElementsByTagName(linktag);
  }
}


// ------------------ Maus & Bildschirmdarstellung ------------------

function clientRect(o) {
  var cr = {  x: 0, y: 0, w: o.offsetWidth||o.clientWidth , h: o.offsetHeight||o.clientHeight }
  while(o!=null) {
    cr.x +=  o.offsetLeft || 0;  // mozilla: .client*
    cr.y +=  o.offsetTop || 0;
    o = o.offsetParent; // mozilla: parentNode
  }
  return cr;
}

function box(x,y,w,h,c) { 
  //document.writeln("<div style='position:absolute; left:"+x+"; top:"+y+"; width:"+w+"; height:"+h+"; background:"+c+"'></div>");
  //alert(x+";"+y+","+w+","+h);
  document.body.innerHTML +=  "<div style='position:absolute; left:"+x+"; top:"+y+"; width:"+w+"; height:"+h+"; background:"+c+"'></div>";
}

function height(o) { return o.offsetHeight||o.clientHeight; }
function width(o) { return o.offsetWidth||o.clientWidth; }

function mousein(e,o) {
  var m = mouseVirtXY(e), cr = clientRect(o);
  cr = {  x: o.offsetLeft , y:  o.offsetTop, w: o.clientWidth , h: o.clientHeight }
  return inbox( m.vx, m.vy, cr.x, cr.y, cr.w, cr.h )
}

function mouseXY(e) {
  if(!e) e=window.event
  if(e.clientX||e.clientY) return { x:e.clientX, y:e.clientY }
  else { if (e.offsetLeft||e.offsetTop) return { x:e.offsetLeft, y:e.offsetTop }
  else return { x: e.pageX - window.pageXOffset, y: e.pageY - window.pageYOffset }; }
}

function mouseVirtXY(e) {
  var m = mouseXY(e);
  m.vx = m.x + window.pageXOffset;
  m.vy = m.y + window.pageYOffset;
  return m;
}

function mouseX(e) {
  if(!e) e=window.event
  if(e.clientX||e.clientY) return e.clientX
  else { if (e.offsetLeft||e.offsetTop) return e.offsetLeft
  else return e.pageX - window.pageXOffset; }
}

function mouseY(e) {
  if(!e) e=window.event
  if(e.clientX||e.clientY) return e.clientY
  else { if (e.offsetLeft||e.offsetTop) return e.offsetTop
  else return e.pageY - window.pageYOffset; }
}


// ------------------ Maus & Bildschirmdarstellung ------------------

function evTarget(ev) {
  if(ev.target) return ev.target;
  return window.event.srcElement;
}

function isParentOfobjID(obj,id) {
  while( obj && (obj.id||obj.getAttribute&&obj.getAttribute('id'))!=id ) { obj = obj.parentNode; } // .getAttribute('id')
  if(!obj||!obj.id) return false;
  return obj.id==id
}

function isParentOf(prn,obj) {
  while( prn && prn!=obj ) { alert(oo(prn.getAttribute('id'))); prn = prn.parentNode; prn=0; } // .getAttribute('id')
  return prn==obj
}
  


// IncludeDocs( "/suse/ValuableFeatures.html", "valuable&nbsp;features &amp; vital&nbsp;issues")



// ------------------ FullScreen Mode ------------------

function openFullScreen(elem) {
  if (elem.requestFullscreen) {
    elem.requestFullscreen();
  } else if (elem.mozRequestFullScreen) { /* Firefox */
    elem.mozRequestFullScreen();
  } else if (elem.webkitRequestFullscreen) { /* Chrome, Safari and Opera */
    elem.webkitRequestFullscreen();
  } else if (elem.msRequestFullscreen) { /* IE/Edge */
    elem.msRequestFullscreen();
  }
}

/* Close fullscreen */
function closeFullScreen() {
  if (document.exitFullscreen) {
    document.exitFullscreen();
  } else if (document.mozCancelFullScreen) { /* Firefox */
    document.mozCancelFullScreen();
  } else if (document.webkitExitFullscreen) { /* Chrome, Safari and Opera */
    document.webkitExitFullscreen();
  } else if (document.msExitFullscreen) { /* IE/Edge */
    document.msExitFullscreen();
  }
}
